--[[
	I've had alot of help building this addon by looking on code from:
	
	World Quest Group Finder https://mods.curse.com/addons/wow/worldquestgroupfinder
	Premade Group Finder https://mods.curse.com/addons/wow/premade-group-finder
	
	Thanks alot for you good work!
	
	Best regards,
	Anders Krüger / Luuci-Frostmane EU
]]
LGFdebug = false

LGFgroupsFound = nil
LGFfoundGroups = {}

LGFcurrentID = 0
LGFcurrentLeader = ""
LGFcurrentActivity = 0

LGFtimeSinceLastUpdate = 0

LGFautoPause = false

function ShowBestResult()
	if LGFdebug then DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFShowBestResult " .. LGFgroupsFound) end
	
	local HighestScoreID = nil
	local HighestScore = -10000000
	local FoundGroupID = 0
	
	for k, v in pairs(LGFfoundGroups) do
		if LGFfoundGroups[k] ~= nil then
			if LGFfoundGroups[k].Score > HighestScore then
				FoundGroupID = k
				HighestScoreID = LGFfoundGroups[k].Id
				HighestScore = LGFfoundGroups[k].Score
			end
		end
	end
	if HighestScoreID ~= nil then
		LGFfoundGroups[FoundGroupID] = nil
		LGFgroupsFound = LGFgroupsFound - 1
		LazyGroupFinder_GroupPopup(HighestScoreID)
	else
		LazyGroupFinderDisableAddon()
	end
end

function LazyGroupFinderEnableAddon()
	if LGFdebug then DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFLazyGroupFinderEnableAddon") end
	C_LFGList.ClearSearchResults()
	C_LFGList.Search(LazyGroupFinderActivityType, LFGListSearchPanel_ParseSearchTerms(""), 0, 4, C_LFGList.GetLanguageSearchFilter())
	LGFtimeSinceLastUpdate = 9
	LazyGroupFinderEnabled = true
	LazyGroupFinder_MinimapButton_SetEnabled()
end

function LazyGroupFinderDisableAddon()
	if LGFdebug then DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFLazyGroupFinderDisableAddon") end
	LazyGroupFinderEnabled = false
	LazyGroupFinder_MinimapButton_SetDisabled()
	for k, v in pairs(LGFfoundGroups) do LGFfoundGroups[k] = nil end
	LGFgroupsFound = nil
	LazyGroupFinderPopup:Hide()
end

local LazyGroupFinderAddon = CreateFrame("Frame", "LazyGroupFinderAddon", UIParent)
local RegisteredEvents = {}
LazyGroupFinderAddon:SetScript("OnEvent", function (self, event, ...) if (RegisteredEvents[event]) then return RegisteredEvents[event](self, event, ...) end end)

function RegisteredEvents:ADDON_LOADED(event, addon, ...)
	if LGFdebug then DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFRegisteredEvents:ADDON_LOADED") end

	if addon ~= "LazyGroupFinder" then return end
	if LazyGroupFinderEnabled == nil then LazyGroupFinderEnabled = false end
	if LazyGroupFinderAchievementOnApply == nil then LazyGroupFinderAchievementOnApply = false end
	if LazyGroupFinderActivityType == nil then LazyGroupFinderActivityType = 3 end
	if LazyGroupFinderActivities == nil then LazyGroupFinderActivities = {} end
	if LazyGroupFinderKeywords == nil then LazyGroupFinderKeywords = "" end
	if LazyGroupFinderBannedwords == nil then LazyGroupFinderBannedwords = "WTS" end
	if LazyGroupFinderMinimapIconPoint == nil then LazyGroupFinderMinimapIconPoint = 180 end
	if LazyGroupFinderMinimapIconHover == nil then LazyGroupFinderMinimapIconHover = false end
	if LazyGroupFinderSoundAnnouncement == nil then LazyGroupFinderSoundAnnouncement = true end
	if LazyGroupFinderChatAnnouncement == nil then LazyGroupFinderChatAnnouncement = false end
	if LazyGroupFinderMinTank == nil then LazyGroupFinderMinTank = "" end
	if LazyGroupFinderMaxTank == nil then LazyGroupFinderMaxTank = "" end
	if LazyGroupFinderMinHeal == nil then LazyGroupFinderMinHeal = "" end
	if LazyGroupFinderMaxHeal == nil then LazyGroupFinderMaxHeal = "" end
	if LazyGroupFinderMinDps == nil then LazyGroupFinderMinDps = "" end
	if LazyGroupFinderMaxDps == nil then LazyGroupFinderMaxDps = "" end
	if LazyGroupFinderMinIlvl == nil then LazyGroupFinderMinIlvl = 0 end
	
	if not LazyGroupFinderMinimapIconHover then LGFminimapIconButton:Show() end
	
	LazyGroupFinderDisableAddon()
	
	LazyGroupFinder_MinimapButton_SetPoint(LazyGroupFinderMinimapIconPoint)
end

function RegisteredEvents:LFG_LIST_SEARCH_RESULTS_RECEIVED(event)
	if LGFdebug then DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFRegisteredEvents:LFG_LIST_SEARCH_RESULTS_RECEIVED: " .. event) end

	if not LazyGroupFinderEnabled then return end
	if LFGListFrame:IsVisible() then
		LazyGroupFinderDisableAddon()
		return
	end

	for k, v in pairs(LGFfoundGroups) do LGFfoundGroups[k] = nil end

	local numResults, results = C_LFGList.GetSearchResults()
	LFGListUtil_SortSearchResults(results)

	for k, v in pairs(results) do
		local id,activity,name,comment,_,ilvl,_,age,_,_,_,isDelisted,leader,members = C_LFGList.GetSearchResultInfo(results[k])

		if leader ~= nil then -- the group needs a leader
			local activityName,_,activityType,_,activityIlvl,_,_,_,_,_ = C_LFGList.GetActivityInfo(activity)

			local groupSetup = C_LFGList.GetSearchResultMemberCounts(id)
			local encounterInfo = C_LFGList.GetSearchResultEncounterInfo(id)
			
			if LazyGroupFinderActivities[activity] == nil then LazyGroupFinderActivities[activity] = false end

			if LazyGroupFinderActivities[activity] == true then
				local groupIgnored = false
				
				local goodGroupSetup = true
				if LazyGroupFinderMinTank ~= "" then
					if tonumber(groupSetup["TANK"]) < tonumber(LazyGroupFinderMinTank) then goodGroupSetup = false end
				end
				if LazyGroupFinderMaxTank ~= "" then
					if tonumber(groupSetup["TANK"]) > tonumber(LazyGroupFinderMaxTank) then goodGroupSetup = false end
				end
				if LazyGroupFinderMinHeal ~= "" then
					if tonumber(groupSetup["HEALER"]) < tonumber(LazyGroupFinderMinHeal) then goodGroupSetup = false end
				end
				if LazyGroupFinderMaxHeal ~= "" then
					if tonumber(groupSetup["HEALER"]) > tonumber(LazyGroupFinderMaxHeal) then goodGroupSetup = false end
				end
				if LazyGroupFinderMinDps ~= "" then
					if tonumber(groupSetup["DAMAGER"]) < tonumber(LazyGroupFinderMinDps) then goodGroupSetup = false end
				end
				if LazyGroupFinderMaxDps ~= "" then
					if tonumber(groupSetup["DAMAGER"]) > tonumber(LazyGroupFinderMaxDps) then goodGroupSetup = false end
				end
				
				if not groupIgnored
					and goodGroupSetup
					and IsKeywordsInWords(LazyGroupFinderKeywords, name .. " " .. comment .. " " .. leader)
					and IsKeywordsNotInWords(LazyGroupFinderBannedwords, name .. " " .. comment .. " " .. leader) 
					and ilvl >= tonumber(LazyGroupFinderMinIlvl) then
					local index = #LGFfoundGroups + 1
					LGFfoundGroups[index] = {}
					LGFfoundGroups[index].Id = id
					LGFfoundGroups[index].Name = name
					LGFfoundGroups[index].Leader = leader
					LGFfoundGroups[index].Activity = activity
					LGFfoundGroups[index].Score = ilvl + members + math.abs(GetAverageItemLevel() - activityIlvl) * -1000
				end
			end
		end
	end
	
	LGFgroupsFound = #LGFfoundGroups
	FlashClientIcon()
	if LazyGroupFinderChatAnnouncement then
		if #LGFfoundGroups == 1 then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFFFFLazy Group Finder:|cFFFFFF00 " .. #LGFfoundGroups .. " groups found.")
		end
		if #LGFfoundGroups > 1 then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFFFFLazy Group Finder:|cFFFFFF00 " .. #LGFfoundGroups .. " group found.")
		end
	end
	if LazyGroupFinderSoundAnnouncement then PlaySound(8960, "master") end
end

function RegisteredEvents:LFG_LIST_SEARCH_RESULT_UPDATED(event, resultsID)
	if not LazyGroupFinderEnabled then return end
	--if LGFdebug then DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFRegisteredEvents:LFG_LIST_SEARCH_RESULT_UPDATED: " .. event) end
	if LFGListFrame:IsVisible() then
		LazyGroupFinderDisableAddon()
		return
	end

	local id,activity,name,comment,_,ilvl,_,age,_,_,_,isDelisted,leader,members = C_LFGList.GetSearchResultInfo(resultsID)

	local activityName,_,activityType,_,activityIlvl,_,_,_,_,_ = C_LFGList.GetActivityInfo(activity)
	
	local groupSetup = C_LFGList.GetSearchResultMemberCounts(id)
	local encounterInfo = C_LFGList.GetSearchResultEncounterInfo(id)
	local deadbosses = " "
	if encounterInfo ~= nil then
		deadbosses = #encounterInfo .. ""
	end
	
	if age ~= nil then
		for k, v in pairs(LGFfoundGroups) do
			if string.lower(name) == string.lower(LGFfoundGroups[k].Name) and string.lower(leader) ~= string.lower(LGFfoundGroups[k].Leader) then --Leader has changed
				if LGFfoundGroups[k].Id == LGFcurrentID then
					LGFcurrentID = id
					LGFcurrentLeader = leader
				end
				LGFfoundGroups[k].Id = id
				LGFfoundGroups[k].Leader = leader
				LGFfoundGroups[k].Score = ilvl + members + math.abs(GetAverageItemLevel() - activityIlvl) * -1000
			elseif string.lower(name) ~= string.lower(LGFfoundGroups[k].Name) and string.lower(leader) == string.lower(LGFfoundGroups[k].Leader) then -- Name has changed
				if LGFfoundGroups[k].Id == LGFcurrentID then
					LGFcurrentID = id
				end
				LGFfoundGroups[k].Id = id
				LGFfoundGroups[k].Name = name
				LGFfoundGroups[k].Score = ilvl + members + math.abs(GetAverageItemLevel() - activityIlvl) * -1000
			elseif isDelisted and string.lower(name) == string.lower(LGFfoundGroups[k].Name) and string.lower(leader) == string.lower(LGFfoundGroups[k].Leader) then -- Group delisted
				if LGFfoundGroups[k].Id == LGFcurrentID then
					-- give new popup
				end
				LGFfoundGroups[k] = nil
				LGFgroupsFound = LGFgroupsFound - 1
			elseif string.lower(name) == string.lower(LGFfoundGroups[k].Name) and string.lower(leader) == string.lower(LGFfoundGroups[k].Leader) then -- Some update
				if LGFfoundGroups[k].Id == LGFcurrentID then
					LGFcurrentID = id
					LGFcurrentActivity = activity
				end
				LGFfoundGroups[k].Id = id
				LGFfoundGroups[k].Activity = activity
				LGFfoundGroups[k].Score = ilvl + members + math.abs(GetAverageItemLevel() - activityIlvl) * -1000
			end
		end
	end
end

function RegisteredEvents:LFG_LIST_APPLICATION_STATUS_UPDATED(event, applicationID, status)
	if LGFdebug then DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFRegisteredEvents:LFG_LIST_APPLICATION_STATUS_UPDATED: " .. event) end

	local _,activity,name,comment,_,ilvl,_,_,_,_,_,_,leader,members = C_LFGList.GetSearchResultInfo(applicationID)
    
	if (status == "applied") then
		if LazyGroupFinderAchievementOnApply then -- SEND ACHIEVEMNT TO LEADER
			achID = GetActivityAchievement(activity)
			if achID ~= nil then
				SendChatMessage(GetAchievementLink(tonumber(achID)), "WHISPER", nil, leader)
			end
		end
	end
end

for k, v in pairs(RegisteredEvents) do
	LazyGroupFinderAddon:RegisterEvent(k)
end

LazyGroupFinderAddon:SetScript("OnUpdate", function(self, elapsed)
	if not LazyGroupFinderEnabled then return end
	
	if LFGListFrame:IsVisible() or LazyGroupFinderOptions:IsVisible() then
		LazyGroupFinderDisableAddon()
		return
	end

	if not LazyGroupFinderPopup:IsVisible() and not LFGListApplicationDialog:IsVisible() then
		if LGFgroupsFound ~= nil then
			ShowBestResult()
		end
	end
end)