LGFachievementIDs = {
	[483] = "12110 11991", -- Antorus, the Burning Throne (Heroic)
	[482] = "12110 11991", -- Antorus, the Burning Throne (Normal)
	[478] = "11874 11790", -- Tomb of Sargeras (Heroic)
	[479] = "11874 11790", -- Tomb of Sargeras (Normal)
	[416] = "11195 10839", -- Nighthold (Heroic)
	[415] = "11195 10839", -- Nighthold (Normal)
	[457] = "11426 11394", -- Trial of valor (Heroic) 
	[456] = "11426 11394", -- Trial of valor (Normal)
	[414] = "11191 11194 10820", -- Emerald Nightmare (Heroic)
	[413] = "11191 11194 10820", -- Emerald Nightmare (Normal)
	[0] = "11162 11185 11184 11183"
}

function GetActivityAchievement(id)
	if LGFdebug then DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFGetActivityAchievement: " .. id) end
	
	if LGFachievementIDs[id] ~= nil then
		for achID in string.gmatch(LGFachievementIDs[id], '([^ ]+)') do
			local _,_,_,completed = GetAchievementInfo(tonumber(achID))
			if completed then
				return tonumber(achID)
			end
		end
	end
	return nil
end

LGFactivityBackgroundIDs = {
	[483] = "Interface\\ENCOUNTERJOURNAL\\UI-EJ-BACKGROUND-Antorus", -- Antorus, the Burning Throne (Heroic)
	[482] = "Interface\\ENCOUNTERJOURNAL\\UI-EJ-BACKGROUND-Antorus", -- Antorus, the Burning Throne (Normal)
	[478] = "Interface\\ENCOUNTERJOURNAL\\UI-EJ-BACKGROUND-TombofSargeras", -- Tomb of Sargeras (Heroic)
	[479] = "Interface\\ENCOUNTERJOURNAL\\UI-EJ-BACKGROUND-TombofSargeras", -- Tomb of Sargeras (Normal)
	[416] = "Interface\\ENCOUNTERJOURNAL\\UI-EJ-BACKGROUND-TheNighthold", -- Nighthold (Heroic)
	[415] = "Interface\\ENCOUNTERJOURNAL\\UI-EJ-BACKGROUND-TheNighthold", -- Nighthold (Normal)
	[457] = "Interface\\ENCOUNTERJOURNAL\\UI-EJ-BACKGROUND-TrialofValor", -- Trial of valor (Heroic) 
	[456] = "Interface\\ENCOUNTERJOURNAL\\UI-EJ-BACKGROUND-TrialofValor", -- Trial of valor (Normal)
	[468] = "Interface\\ENCOUNTERJOURNAL\\UI-EJ-BACKGROUND-TheEmeraldNightmare", -- Emerald Nightmare (Mythic)
	[414] = "Interface\\ENCOUNTERJOURNAL\\UI-EJ-BACKGROUND-TheEmeraldNightmare", -- Emerald Nightmare (Heroic)
	[413] = "Interface\\ENCOUNTERJOURNAL\\UI-EJ-BACKGROUND-TheEmeraldNightmare", -- Emerald Nightmare (Normal)
	
}

function GetActivityBackground(id)
	if LGFdebug then DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFGetActivityBackground: " .. id) end
	
	if LGFactivityBackgroundIDs[id] ~= nil then
		return LGFactivityBackgroundIDs[id]
	else
		return "Interface\\ENCOUNTERJOURNAL\\UI-EJ-BACKGROUND-BrokenIsles"
	end
end

function IsKeywordsInWords(keywords, words)
	--if LGFdebug then DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFIsKeywordsInWords") end
	
	if keywords == "" then return true end
	for keyword in string.gmatch(string.lower(keywords), '([^ ]+)') do
		if string.match(string.lower(words), keyword) then
			return true
		end
	end
	return false
end

function IsKeywordsNotInWords(keywords, words)
	--if LGFdebug then DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FFIsKeywordsNotInWords") end
	
	if keywords == "" then return true end
	for keyword in string.gmatch(string.lower(keywords), '([^ ]+)') do
		if string.match(string.lower(words), keyword) then
			return false
		end
	end
	return true
end